Subject: Re: [PATCH v3] nfp: fix use-after-free in area_cache_get()

From: Lee Jones <[email-masked]>
Date: Thu, 15 Dec 2022 09:25:23 +0000

Dear Stable,

[NB: Re-poking Stable with the correct contact address this time! :)]

> > > area_cache_get() is used to distribute cache->area and set cache->id,
> > >  and if cache->id is not 0 and cache->area->kref refcount is 0, it will
> > >  release the cache->area by nfp_cpp_area_release(). area_cache_get()
> > >  set cache->id before cpp->op->area_init() and nfp_cpp_area_acquire().
> > >
> > > But if area_init() or nfp_cpp_area_acquire() fails, the cache->id is
> > >  is already set but the refcount is not increased as expected. At this
> > >  time, calling the nfp_cpp_area_release() will cause use-after-free.
> > >
> > > To avoid the use-after-free, set cache->id after area_init() and
> > >  nfp_cpp_area_acquire() complete successfully.
> > >
> > > Note: This vulnerability is triggerable by providing emulated device
> > >  equipped with specified configuration.
> > >
> > >  BUG: KASAN: use-after-free in nfp6000_area_init (/home/user/Kernel/v5.19
> > > /x86_64/src/drivers/net/ethernet/netronome/nfp/nfpcore/nfp6000_pcie.c:760)
> > >   Write of size 4 at addr ffff888005b7f4a0 by task swapper/0/1
> > >
> > >  Call Trace:
> > >   <TASK>
> > >  nfp6000_area_init (/home/user/Kernel/v5.19/x86_64/src/drivers/net
> > > /ethernet/netronome/nfp/nfpcore/nfp6000_pcie.c:760)
> > >  area_cache_get.constprop.8 (/home/user/Kernel/v5.19/x86_64/src/drivers
> > > /net/ethernet/netronome/nfp/nfpcore/nfp_cppcore.c:884)
> > >
> > >  Allocated by task 1:
> > >  nfp_cpp_area_alloc_with_name (/home/user/Kernel/v5.19/x86_64/src/drivers
> > > /net/ethernet/netronome/nfp/nfpcore/nfp_cppcore.c:303)
> > >  nfp_cpp_area_cache_add (/home/user/Kernel/v5.19/x86_64/src/drivers/net
> > > /ethernet/netronome/nfp/nfpcore/nfp_cppcore.c:802)
> > >  nfp6000_init (/home/user/Kernel/v5.19/x86_64/src/drivers/net/ethernet
> > > /netronome/nfp/nfpcore/nfp6000_pcie.c:1230)
> > >  nfp_cpp_from_operations (/home/user/Kernel/v5.19/x86_64/src/drivers/net
> > > /ethernet/netronome/nfp/nfpcore/nfp_cppcore.c:1215)
> > >  nfp_pci_probe (/home/user/Kernel/v5.19/x86_64/src/drivers/net/ethernet
> > > /netronome/nfp/nfp_main.c:744)
> > >
> > >  Freed by task 1:
> > >  kfree (/home/user/Kernel/v5.19/x86_64/src/mm/slub.c:4562)
> > >  area_cache_get.constprop.8 (/home/user/Kernel/v5.19/x86_64/src/drivers
> > > /net/ethernet/netronome/nfp/nfpcore/nfp_cppcore.c:873)
> > >  nfp_cpp_read (/home/user/Kernel/v5.19/x86_64/src/drivers/net/ethernet
> > > /netronome/nfp/nfpcore/nfp_cppcore.c:924 /home/user/Kernel/v5.19/x86_64
> > > /src/drivers/net/ethernet/netronome/nfp/nfpcore/nfp_cppcore.c:973)
> > >  nfp_cpp_readl (/home/user/Kernel/v5.19/x86_64/src/drivers/net/ethernet
> > > /netronome/nfp/nfpcore/nfp_cpplib.c:48)
> > >
> > > Signed-off-by: Jialiang Wang <[email-masked]>
> > 
> > Any reason why this doesn't have a Fixes: tag applied and/or didn't
> > get sent to Stable?
> > 
> > Looks as if this needs to go back as far as v4.19.
> > 
> > Fixes: 4cb584e0ee7df ("nfp: add CPP access core")
> > 
> > commit 02e1a114fdb71e59ee6770294166c30d437bf86a upstream.

Would you be able to take this with the information provided please?

-- 
Lee Jones [李琼斯]